edu.wpi.first.wpilibj.hal

## Class PWMJNI

- java.lang.Object
- - edu.wpi.first.wpilibj.hal.JNIWrapper
  - - edu.wpi.first.wpilibj.hal.DIOJNI
    - - edu.wpi.first.wpilibj.hal.PWMJNI

-     public class PWMJNI
      extends DIOJNI

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `PWMJNI()`

  - ### Method Summary

    All Methods Static Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static boolean` | `checkPWMChannel(int channel)`
    `static void` | `freePWMPort(int pwmPortHandle)`
    `static PWMConfigDataResult` | `getPWMConfigRaw(int pwmPortHandle)`
    `static boolean` | `getPWMEliminateDeadband(int pwmPortHandle)`
    `static double` | `getPWMPosition(int pwmPortHandle)`
    `static short` | `getPWMRaw(int pwmPortHandle)`
    `static double` | `getPWMSpeed(int pwmPortHandle)`
    `static int` | `initializePWMPort(int halPortHandle)`
    `static void` | `latchPWMZero(int pwmPortHandle)`
    `static void` | `setPWMConfig(int pwmPortHandle, double maxPwm, double deadbandMaxPwm, double centerPwm, double deadbandMinPwm, double minPwm)`
    `static void` | `setPWMConfigRaw(int pwmPortHandle, int maxPwm, int deadbandMaxPwm, int centerPwm, int deadbandMinPwm, int minPwm)`
    `static void` | `setPWMDisabled(int pwmPortHandle)`
    `static void` | `setPWMEliminateDeadband(int pwmPortHandle, boolean eliminateDeadband)`
    `static void` | `setPWMPeriodScale(int pwmPortHandle, int squelchMask)`
    `static void` | `setPWMPosition(int pwmPortHandle, double position)`
    `static void` | `setPWMRaw(int pwmPortHandle, short value)`
    `static void` | `setPWMSpeed(int pwmPortHandle, double speed)`

    - ### Methods inherited from class edu.wpi.first.wpilibj.hal.DIOJNI

      `allocateDigitalPWM, checkDIOChannel, freeDigitalPWM, freeDIOPort, getDIO, getDIODirection, getLoopTiming, initializeDIOPort, isAnyPulsing, isPulsing, pulse, setDigitalPWMDutyCycle, setDigitalPWMOutputChannel, setDigitalPWMRate, setDIO`

    - ### Methods inherited from class edu.wpi.first.wpilibj.hal.JNIWrapper

      `getPort, getPortWithModule`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### PWMJNI

          public PWMJNI()

  - ### Method Detail

    - #### initializePWMPort

          public static int initializePWMPort(int halPortHandle)

    - #### checkPWMChannel

          public static boolean checkPWMChannel(int channel)

    - #### freePWMPort

          public static void freePWMPort(int pwmPortHandle)

    - #### setPWMConfigRaw

          public static void setPWMConfigRaw(int pwmPortHandle,
                                             int maxPwm,
                                             int deadbandMaxPwm,
                                             int centerPwm,
                                             int deadbandMinPwm,
                                             int minPwm)

    - #### setPWMConfig

          public static void setPWMConfig(int pwmPortHandle,
                                          double maxPwm,
                                          double deadbandMaxPwm,
                                          double centerPwm,
                                          double deadbandMinPwm,
                                          double minPwm)

    - #### getPWMConfigRaw

          public static PWMConfigDataResult getPWMConfigRaw(int pwmPortHandle)

    - #### setPWMEliminateDeadband

          public static void setPWMEliminateDeadband(int pwmPortHandle,
                                                     boolean eliminateDeadband)

    - #### getPWMEliminateDeadband

          public static boolean getPWMEliminateDeadband(int pwmPortHandle)

    - #### setPWMRaw

          public static void setPWMRaw(int pwmPortHandle,
                                       short value)

    - #### setPWMSpeed

          public static void setPWMSpeed(int pwmPortHandle,
                                         double speed)

    - #### setPWMPosition

          public static void setPWMPosition(int pwmPortHandle,
                                            double position)

    - #### getPWMRaw

          public static short getPWMRaw(int pwmPortHandle)

    - #### getPWMSpeed

          public static double getPWMSpeed(int pwmPortHandle)

    - #### getPWMPosition

          public static double getPWMPosition(int pwmPortHandle)

    - #### setPWMDisabled

          public static void setPWMDisabled(int pwmPortHandle)

    - #### latchPWMZero

          public static void latchPWMZero(int pwmPortHandle)

    - #### setPWMPeriodScale

          public static void setPWMPeriodScale(int pwmPortHandle,
                                               int squelchMask)